package filter.examples;

import java.io.IOException;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

public class VerifyLogonFilter implements Filter {
	private FilterConfig filterConfig;

	public void doFilter(ServletRequest request, ServletResponse response,
			FilterChain chain) {

		RequestDispatcher rd = null;
		HttpSession session = ((HttpServletRequest) request).getSession();
		try {

		
			String sessionAttributeName = filterConfig.getInitParameter("felhasznalonev");
		
			// nincs init parameter megadva a web.xml-ben, hivjuk a kovetkezo szurot (ha van ilyen) vagy a servletet
			if (sessionAttributeName == null) {
				System.out.println("Nincs mit ellenorizni");
				chain.doFilter(request, response);
			}

			// leellenorzi, hogy be van-e allitva a szesszioban egy olyan attributum, aminek a neve 
			//az init parameter ertekenek felel meg
			else {
				
					String sessionAttributeValue = (String) session
							.getAttribute(sessionAttributeName);


					if (sessionAttributeValue == null) {
						// ha nem letezik, akkor visszairanyit a login oldalra
						rd = request.getRequestDispatcher("/LoginServlet.do");
						rd.forward(request, response);
					}

					// ha letezik (mar be volt jelentkezve), akkor "tovabbenged" 
				chain.doFilter(request, response);
				
			}

		}

		catch (IOException io) {
			System.out.println("IOException dobódott...");
		} catch (ServletException se) {
			System.out.println("ServletException dobódott...");
		}

	}

	public void destroy() {

	}

	public void init(FilterConfig filterConfig) throws ServletException {
		this.filterConfig = filterConfig;

	}
}
