package servlet.examples.session;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.Date;
import java.util.Enumeration;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;


public class SessionSnoop extends HttpServlet {


	private static final long serialVersionUID = 1L;

	public void doGet(HttpServletRequest req, HttpServletResponse res)
	                               throws ServletException, IOException {
	    res.setContentType("text/html");
	    res.setCharacterEncoding("UTF-8");
	    PrintWriter out = res.getWriter();
	
	    // Lekeri a szessziot a request objektumbol
	    HttpSession session = req.getSession();
	
	    // Noveli a count erteket minden egyes hivasra es lementi azt a szesszioba 
	    //  "snoop.count" nev alatt
	    Integer count = (Integer)session.getAttribute("snoop.count");
	    if (count == null){
	      count = new Integer(1);
	    }
	    else{
	      count = new Integer(count.intValue() + 1);
	    }  
	    session.setAttribute("snoop.count", count);
	
	    out.println("<HTML><HEAD><TITLE>SessionSnoop</TITLE></HEAD>");
	    out.println("<BODY><H1>Session Snoop</H1>");
	
	    // kiirja a count erteket
	    out.println("Ezt az oldalt " + count +
	      " alkalommal látogattad meg");
	
	    out.println("<P>");
	
	    out.println("<H3>A szesszióba lementett adatok:</H3>");

		Enumeration<String> names = session.getAttributeNames();
	    while (names.hasMoreElements()) {
	      String name = names.nextElement();
	      out.println(name + ": " + session.getAttribute(name) + "<BR>");
	    }
	
	    out.println("<H3>Infó az aktuális szesszióról:</H3>");
	    out.println("Szesszió ID: " + session.getId() +
	                " <I>(...titkos)</I><BR>");
	    out.println("Új szesszió: " + session.isNew() + "<BR>");
	    out.println("Lejárási idő: " + session.getMaxInactiveInterval());
	    out.println("<I>(" + session.getMaxInactiveInterval() / 60 + 
	                " perc)</I><BR>");
	    out.println("Létrehozás ideje: " + session.getCreationTime());
	    out.println("<I>(" + new Date(session.getCreationTime()) + ")</I><BR>");
	    out.println("Utolsó hozzáférés ideje: " + session.getLastAccessedTime());
	    out.println("<I>(" + new Date(session.getLastAccessedTime()) +
	                ")</I><BR>");
	
	    out.println("Cookie-ból lekért szesszió ID: " +
	                req.isRequestedSessionIdFromCookie() + "<BR>");
	    out.println("URL-ből lekért szesszió ID: " +
	                req.isRequestedSessionIdFromURL() + "<BR>");
	    
	    out.println("<H3>URL átírás tesztelése</H3>");
	    out.println(" <A HREF=\"" +
	                res.encodeURL(req.getRequestURI()) + "\">klikk</A>");
	    out.println("annak tesztelése, hogy URL átírás segítségével történik-e a szessziókövetés");
	    out.println(" cookie letiltása esetén.");
	
	    out.println("</BODY></HTML>");
	  }
}
