package servlet.examples.snooper;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.Enumeration;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


public class ParameterSnoop extends HttpServlet {

	private static final long serialVersionUID = 1L;


public void doGet(HttpServletRequest req, HttpServletResponse res)
                               throws ServletException, IOException {
    res.setContentType("text/plain");
    res.setCharacterEncoding("UTF-8");
    PrintWriter out = res.getWriter();

    out.println("Kérés paraméterek (Query String):");
    out.println(req.getQueryString());
    out.println();

    out.println("Paraméterek egyenként (Request Parameters):");
 
	Enumeration<String> names = req.getParameterNames();
    while (names.hasMoreElements()) {
      String name = (String) names.nextElement();
      String values[] = req.getParameterValues(name);
      if (values != null) {
        for (int i = 0; i < values.length; i++) {
          out.println(name + " (" + i + "): " + values[i]);
        }
      }
    }
    out.println("Context path:");
    out.println(" req.getContextPath(): " +  req.getContextPath());
    out.println(" req.getServletPath(): " +  req.getServletPath());
    out.println(" getServletContext().getRealPath(req.getServletPath()): " +  getServletContext().getRealPath(req.getServletPath()));
   
  }
} 
